#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#      tcpserver.py
#
#      Copyright 2014 Recursos Python - www.recursospython.com
#
#

import stackless
import stacklesssocket; stacklesssocket.install()

from socket import socket, error as socket_error

def run_socket(conn, name):
    print("%s conectado." % name)
    while True:
        try:
            # Recibir datos del cliente.
            input_data = conn.recv(1024)
        except socket_error as e:
            print("[%s] %s" % (name, e))
            break
        else:
            if len(input_data) == 0:
                break
            # Reenviar la información recibida.
            elif input_data:
                conn.send(input_data)
    print("%s desconectado." % name)


def listener():
    s = socket()
    
    # Escuchar peticiones en el puerto 6030.
    s.bind(("localhost", 6030))
    s.listen(0)
    
    while True:
        conn, addr = s.accept()
        new_tasklet = stackless.tasklet(run_socket)(conn, "%s:%d" % addr)
        new_tasklet.insert()
        stackless.schedule()


def main():
    stackless.tasklet(listener)()
    stackless.run()


if __name__ == "__main__":
    main()